<template>
    <section>
        <Notificacao 
            v-if="getState.notificacao.show"
        />
        <div class="cabecalho-cadastro">
            <material-icon type="mdi" :path="mdiAccountCheckOutline" size="40" /> Cadastro
        </div>
        <div class="field">
            <label class="label">Nome </label>
            <div class="control">
                <input class="input" type="text" placeholder="Nome completo" v-model="state.form.name">
            </div>
        </div>

        <div class="field">
            <label class="label">E-mail</label>
            <div class="control">
                <input class="input" type="email" placeholder="exemplo@exemplo.com" v-model="state.form.email">
            </div>
        </div>

        <div class="field">
            <label class="label">Password</label>
            <div class="control">
                <input class="input" type="password" placeholder="Senha" v-model="state.form.password">
            </div>
        </div>

        <div class="buttons">
            <button class="button" @click="$router.push({ name: 'home' })">
                <material-icon type="mdi" :path="mdiArrowLeft" size="20" />
            </button>            
            <button class="button is-success" @click="efetuarCadastro()">Cadastrar</button>
        </div>
    </section>
</template>
<script>
import { mdiAccountCheckOutline, mdiArrowLeft } from '@mdi/js'
import { reactive } from '@vue/reactivity'
import { requestPOST } from '../../services/http/index'
import { getState, setNotificacao } from '../../store'
import Notificacao from '../modules/bulma/Notificacao.vue'

export default {
    components: {
        Notificacao
    },
    setup() {
        
        const state = reactive({
            form: {
                name: null,
                email: null,
                password: null
            },
            alertaNotificacao: false
        })

        const efetuarCadastro = () => {
            requestPOST(`${getState.env.VUE_APP_URL_API_LOJA}/cadastro`, state.form).then(response => {
                setNotificacao({
                    show: true,
                    mensagem: `Cadastro realizado! ID: ${response.data.id}`
                })
            }).catch(e => {
                setNotificacao({
                    show: true,
                    mensagem: e.response.data.message
                })
            })
        }

        return {
            mdiAccountCheckOutline,
            mdiArrowLeft,
            state,
            getState,
            efetuarCadastro
        }
    }
}
</script>

<style scoped>
    section {
        max-width: 30em;
        margin: auto;
        display: flex;
        box-shadow: #00000073 1px 4px 16px 0px;
        background-color: #00000003;
        padding: 15px;
        margin-top: 5em;
        flex-direction: column;
    }
    .buttons {
        display: flex;
        justify-content: space-between;
        margin-top: 1em;
        margin-bottom: 1em;
    }
    .cadastro button {
        width: 100%;
    }
    .cabecalho-cadastro {
        margin: auto;
        margin-top: .7em;
        margin-bottom: .7em;
        display: flex;
        align-items: center;
        justify-content: space-between;
        width: 5.7em;
        font-size: 2em;    
    }
</style>